package com.csversion2;

import java.text.DecimalFormat;
import java.util.List;

import android.content.Context;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.graphics.PixelFormat;
import android.hardware.Sensor;
import android.hardware.SensorManager;
import android.location.Location;
import android.location.LocationListener;
import android.opengl.GLSurfaceView;
import android.os.Bundle;
import android.os.PowerManager;
import android.view.ViewGroup.LayoutParams;
import android.widget.FrameLayout;
import android.widget.SeekBar;
import android.widget.Toast;

import java.util.Locale;
import java.util.Map;
import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.BlockingQueue;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.RejectedExecutionException;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;
import com.csversion2.R;
import com.csversion2.activity.AugmentedReality;
import com.csversion2.activity.AugmentedView;
import com.csversion2.camera.CameraSurface;
import com.csversion2.data.ARData;
import com.csversion2.data.LocalDataSource;
import com.csversion2.data.NetworkDataSource;
import com.csversion2.ui.Marker;
import com.csversion2.widget.VerticalSeekBar;
import com.csversion2.widget.VerticalTextView;

import android.graphics.Color;
import android.text.InputFilter.LengthFilter;
import android.util.Log;
import android.view.Gravity;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.widget.LinearLayout;
import android.widget.SeekBar.OnSeekBarChangeListener;

public class CSversion2 extends AugmentedReality {
	
	private static final DecimalFormat FORMAT = new DecimalFormat("#.##");
	private static final int ZOOMBAR_BACKGROUND_COLOR = Color.argb(125, 55, 55, 55);
	private static final String END_TEXT = FORMAT.format(AugmentedReality.MAX_ZOOM) + " km";
	private static final int END_TEXT_COLOR = Color.WHITE;

	private static final String TAG = "CSversion2";
	private static final String locale = Locale.getDefault().getLanguage();
	private static final BlockingQueue<Runnable> queue = new ArrayBlockingQueue<Runnable>(1);
	private static final ThreadPoolExecutor exeService = new ThreadPoolExecutor(1, 1, 20, TimeUnit.SECONDS, queue);
	private static final Map<String, NetworkDataSource> sources = new ConcurrentHashMap<String, NetworkDataSource>();
	private static Toast myToast = null;
	private static VerticalTextView text = null;

	private SensorManager mSensorManager;
	private GLSurfaceView mGLSurfaceView;
	public Location ult_loc;
	
	public String bestProvider;
	public boolean gps_enabled, network_enabled;
	
	public String ruta, idioma;
    
//	private LocationManager locationManager;
    LocationListener locationListener = new LocationListener() {
		public void onLocationChanged(Location location) {
			ult_loc = location;
		}

		public void onProviderDisabled(String provider) {
		}

		public void onProviderEnabled(String provider) {
		}

		public void onStatusChanged(String provider, int status, Bundle extra) {
		}
	};

	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		// matengo la vista de la pantalla en horizontal para mostrar mejor los elementos
		setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
		setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE);
		
		// cojo la ruta que quiere hacer el usuario
		Intent i = getIntent();
		this.ruta = i.getStringExtra("ruta");
		
		// creo los POIs
		crearMarcadores();
		
		// creo la ruta en "pois"
		crearRuta();

		// superficie GL para mostrar la flecha 3D
		mGLSurfaceView = new GLSurfaceView(this);
		mGLSurfaceView.setEGLConfigChooser(8, 8, 8, 8, 16, 0);
		CompassRenderer compassRenderer = new CompassRenderer(this);
		mGLSurfaceView.setRenderer(compassRenderer);
		mGLSurfaceView.getHolder().setFormat(PixelFormat.TRANSLUCENT);
		this.setContentView(mGLSurfaceView);
		
		// CDIGO QUE ESTABA EN EL PADRE PARA PONER LA VISTA DE LA CMARA
		// Y PINTAR LOS CONTROLES DE AR
		
		// muestro la vista de la cmara en vez de la flecha sobre negro EN EL PADRE CAMERASURFACE
        LayoutParams augLayout = new LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT);

        camScreen = new CameraSurface(this);
        addContentView(camScreen, augLayout);

        augmentedView = new AugmentedView(this);
        augmentedView.setOnTouchListener(this);
        addContentView(augmentedView,augLayout);
        
        zoomLayout = new LinearLayout(this);
        zoomLayout.setVisibility((showZoomBar)?LinearLayout.VISIBLE:LinearLayout.GONE);
        zoomLayout.setOrientation(LinearLayout.VERTICAL);
        zoomLayout.setPadding(5, 5, 5, 5);
        zoomLayout.setBackgroundColor(ZOOMBAR_BACKGROUND_COLOR);

        endLabel = new VerticalTextView(this);
        endLabel.setText(END_TEXT);
        endLabel.setTextColor(END_TEXT_COLOR);
        LinearLayout.LayoutParams zoomTextParams = new LinearLayout.LayoutParams(LayoutParams.WRAP_CONTENT,LayoutParams.WRAP_CONTENT);
        zoomTextParams.gravity = Gravity.CENTER;
        zoomLayout.addView(endLabel, zoomTextParams);

        myZoomBar = new VerticalSeekBar(this);
        myZoomBar.setMax(100);
        myZoomBar.setProgress(50);
        myZoomBar.setOnSeekBarChangeListener(myZoomBarOnSeekBarChangeListener);
        LinearLayout.LayoutParams zoomBarParams =  new LinearLayout.LayoutParams(LayoutParams.WRAP_CONTENT,LayoutParams.FILL_PARENT);
        zoomBarParams.gravity = Gravity.CENTER_HORIZONTAL;
        zoomLayout.addView(myZoomBar, zoomBarParams);

        FrameLayout.LayoutParams frameLayoutParams = new FrameLayout.LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.FILL_PARENT, Gravity.RIGHT);
        addContentView(zoomLayout,frameLayoutParams);
        
        updateDataOnZoom();
		
        // FIN DEL CDIGO DEL PADRE
        
		// obtengo los sensores necesarios del telfono
		mSensorManager = (SensorManager) getSystemService(SENSOR_SERVICE);
		List<Sensor> listSensors = mSensorManager
				.getSensorList(Sensor.TYPE_ACCELEROMETER);
		if (listSensors.size() > 0) {
			mSensorManager.registerListener(compassRenderer,
					listSensors.get(0), SensorManager.SENSOR_DELAY_UI);
		}

		listSensors = mSensorManager.getSensorList(Sensor.TYPE_MAGNETIC_FIELD);
		if (listSensors.size() > 0) {
			mSensorManager.registerListener(compassRenderer,
					listSensors.get(0), SensorManager.SENSOR_DELAY_UI);
		}
	}

	private void crearMarcadores() {
		// Create toast
		myToast = new Toast(getApplicationContext());
		myToast.setGravity(Gravity.CENTER, 0, 0);
		// Creating our custom text view, and setting text/rotation
		text = new VerticalTextView(getApplicationContext());
		LayoutParams params = new LayoutParams(LayoutParams.WRAP_CONTENT,
				LayoutParams.WRAP_CONTENT);
		text.setLayoutParams(params);
		text.setBackgroundResource(android.R.drawable.toast_frame);
		text.setTextAppearance(getApplicationContext(),
				android.R.style.TextAppearance_Small);
		text.setShadowLayer(2.75f, 0f, 0f, Color.parseColor("#BB000000"));
		myToast.setView(text);
		// Setting duration and displaying the toast
		myToast.setDuration(Toast.LENGTH_LONG);
		
		// cojo el idioma que quiere usar el usuario
		Intent i = getIntent();
		this.idioma = i.getStringExtra("language");
 
		// Local
		LocalDataSource localData = new LocalDataSource(this.getResources(), null, idioma);
		ARData.addMarkers(localData.getMarkers());
	}
	
	public void crearRuta(){
		LocalDataSource localData = new LocalDataSource(this.getResources(), this.ruta, null);
		ARData.addRouteMarkers(localData.getRouteMarkers());
	}

	private OnSeekBarChangeListener myZoomBarOnSeekBarChangeListener = new OnSeekBarChangeListener() {
		public void onProgressChanged(SeekBar seekBar, int progress,
				boolean fromUser) {
			updateDataOnZoom();
			camScreen.invalidate();
		}

		public void onStartTrackingTouch(SeekBar seekBar) {
			// Ignore
		}

		public void onStopTrackingTouch(SeekBar seekBar) {
			updateDataOnZoom();
			camScreen.invalidate();
		}
	};

	@Override
	public void onStart() {
		super.onStart();

		Location last = ARData.getCurrentLocation();
		updateData(last.getLatitude(), last.getLongitude(), last.getAltitude());
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		MenuInflater inflater = getMenuInflater();
		inflater.inflate(R.layout.menu, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		Log.v(TAG, "onOptionsItemSelected() item=" + item);
		switch (item.getItemId()) {
		case R.id.showRadar:
			showRadar = !showRadar;
			item.setTitle(((showRadar) ? "Hide" : "Show") + " Radar");
			break;
		case R.id.showZoomBar:
			showZoomBar = !showZoomBar;
			item.setTitle(((showZoomBar) ? "Hide" : "Show") + " Zoom Bar");
			zoomLayout.setVisibility((showZoomBar) ? LinearLayout.VISIBLE
					: LinearLayout.GONE);
			break;
		case R.id.exit:
			finish();
			break;
		}
		return true;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void onLocationChanged(Location location) {
		super.onLocationChanged(location);

		updateData(location.getLatitude(), location.getLongitude(),
				location.getAltitude());
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	protected void markerTouched(Marker marker) {
		text.setText(marker.getDesc());
		myToast.show();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	protected void updateDataOnZoom() {
		super.updateDataOnZoom();
		Location last = ARData.getCurrentLocation();
		updateData(last.getLatitude(), last.getLongitude(), last.getAltitude());
	}

	private void updateData(final double lat, final double lon, final double alt) {
		try {
			exeService.execute(new Runnable() {
				@Override
				public void run() {
					for (NetworkDataSource source : sources.values())
						download(source, lat, lon, alt);
				}
			});
		} catch (RejectedExecutionException rej) {
			Log.w(TAG, "Not running new download Runnable, queue is full.");
		} catch (Exception e) {
			Log.e(TAG, "Exception running download Runnable.", e);
		}
	}

	private static boolean download(NetworkDataSource source, double lat,
			double lon, double alt) {
		if (source == null)
			return false;

		String url = null;
		try {
			url = source.createRequestURL(lat, lon, alt, ARData.getRadius(),
					locale);
		} catch (NullPointerException e) {
			return false;
		}

		List<Marker> markers = null;
		try {
			markers = source.parse(url);
		} catch (NullPointerException e) {
			return false;
		}

		ARData.addMarkers(markers);
		return true;
	}

	@Override
	public void onResume() {
		super.onResume();
		mGLSurfaceView.onResume();
		// esto es para que al salir de la aplicacin, se dibuje de nuevo la flecha
		// que no se porque al volver se pinta por cdigo pero no aparece en la pantalla
		setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
		setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE);
	}

	@Override
	public void onPause() {
		super.onPause();
		mGLSurfaceView.onPause();
		
		// esto es para que al salir de la aplicacin, se dibuje de nuevo la flecha
		// que no se porque al volver se pinta por cdigo pero no aparece en la pantalla
		setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
		setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE);
	}

	@Override
	protected void onRestoreInstanceState(Bundle savedInstanceState) {
		super.onRestoreInstanceState(savedInstanceState);
	}

	protected void onSaveInstanceState(Bundle outState) {
		super.onSaveInstanceState(outState);
	}

	protected void onStop() {
		super.onStop();
	}
}