package com.csversion2;

import com.csversion2.R;

import android.app.Activity;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

public class CreadorBD extends Activity {

	private AppPreferences AP;

	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		// matengo la vista de la pantalla en horizontal para mostrar mejor los elementos
		setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);

		setContentView(R.layout.crearbd);
		
		TextView tv = (TextView) findViewById(R.id.textView1);
		String s = "This application will guide you through the Camino de Santiago. It works with GPS or network.";
		s += System.getProperty("line.separator") + System.getProperty("line.separator") + "The arrow points to the nearest point of the route you have choosen.";
		s += System.getProperty("line.separator") + System.getProperty("line.separator") + "Some points of interest will appear in augmented reality when looking at their direction.";
		s += System.getProperty("line.separator") + System.getProperty("line.separator") + "You have a radar which locates those POIs and a bar which indicates the maximum distance to show the POIs.";
		s += System.getProperty("line.separator") + System.getProperty("line.separator") + "Have a nice trip!";
		tv.setText(s);

		// Con SharedPreferences guardo informacin de si es mi primera vez
		// usando la aplicacin
		// para crear la base de datos o no
		this.AP = new AppPreferences(this);
		String primeraVez = this.AP.getPrimeraVez();

		if (primeraVez.equals("si")) {
			this.AP.setPrimeraVez("no");
			// llamar a la actividad de configuracin de la app
			Intent i = new Intent(this, Configurar.class);
			startActivity(i);
		}
		else{
			crearBD();
		}
	}

	public void crearBD() {
		String ruta = this.AP.getOpt1();
		if(ruta.equals("NOR")){
			ruta = "RutaCaminoNorte.db";
		}
		else if(ruta.equals("NORP")){
			ruta = "RutaCaminoNortePrimitivo.db";
		}
		else if(ruta.equals("FRA")){
			ruta = "RutaCaminoFrances.db";
		}
		
		String lang = this.AP.getOpt3();
		if(lang.equals("ENG")){
			lang = "poisIngles.db";
		}
		else if(lang.equals("SPA")){
			lang = "pois.db";
		}
		
		generadorRuta Ruta = new generadorRuta(this, ruta);
		generadorRuta Pois = new generadorRuta(this, null, lang);

		try {
			this.AP.setPrimeraVez("no");

			Ruta.createDataBase();
			Pois.createDataBasePois();
		} catch (Exception e) {
			Ruta.close();
			Pois.close();
		}

		Ruta.close();
		Pois.close();

		Button cerrar = (Button) findViewById(R.id.cerrar);

		cerrar.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {
				cerrar(v);
			}
		});
	}

	public void cerrar(View view) {
		String ruta = this.AP.getOpt1();
		if(ruta.equals("NOR")){
			ruta = "RutaCaminoNorte.db";
		}
		else if(ruta.equals("NORP")){
			ruta = "RutaCaminoNortePrimitivo.db";
		}
		else if(ruta.equals("FRA")){
			ruta = "RutaCaminoFrances.db";
		}
		
		String upd = this.AP.getOpt2();
		
		String lang = this.AP.getOpt3();
		if(lang.equals("ENG")){
			lang = "poisIngles.db";
		}
		else if(lang.equals("SPA")){
			lang = "pois.db";
		}

		finish();
		
		Intent i = new Intent(this, CSversion2.class);
		i.putExtra("ruta", ruta);
		i.putExtra("updates", upd);
		i.putExtra("language", lang);
        startActivity(i);
	}

	public AppPreferences devolverPreferences() {
		return this.AP;
	}

	@Override
	protected void onResume() {
		super.onResume();
	}

	@Override
	protected void onPause() {
		super.onPause();
	}

	@Override
	protected void onRestoreInstanceState(Bundle savedInstanceState) {
		super.onRestoreInstanceState(savedInstanceState);
	}

	protected void onSaveInstanceState(Bundle outState) {
		super.onSaveInstanceState(outState);
	}

	protected void onStop() {
		super.onStop();
	}

	public void onDestroy() {
		super.onDestroy();
	}
}