package com.csversion2;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import android.content.Context;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteException;
import android.database.sqlite.SQLiteOpenHelper;

public class generadorRuta extends SQLiteOpenHelper {

	/**
	 * @param args
	 */
//	private static final String DATABASE_COMPRESSED = "RutaPamplona.jet";
	private String DATABASE_NAME = null;

	private String DATABASE_NAME_POIS = "pois.db";

	private static final String DATABASE_PATH = "/data/data/com.csversion2/databases/";

	private Context myContext;
	private SQLiteDatabase database, databasePois;

	// Constructor de la clase
	public generadorRuta(Context context, String database) {
		super(context, database, null, 1);

		this.DATABASE_NAME = database;
		this.myContext = context;
	}

	public generadorRuta(Context context, String s, String s2) {
		super(context, s2, null, 1);
		
		this.DATABASE_NAME_POIS = s2;
		this.myContext = context;
	}

	public void createDataBase() throws IOException {
		boolean dbExist = checkDataBase();

		if (dbExist) {
			// do nothing - database already exist
		} else {
			// By calling this method and empty database will be created into
			// the default system path
			// of your application so we are gonna be able to overwrite that
			// database with our database.
			this.getReadableDatabase();

			try {
				copyDataBase();
			} catch (IOException e) {
				throw new Error("Error copying database");
			}
		}
	}

	public void createDataBasePois() throws IOException {
		boolean dbExist = checkDataBasePois();

		if (dbExist) {
			// do nothing - database already exist
		} else {
			// By calling this method and empty database will be created into
			// the default system path
			// of your application so we are gonna be able to overwrite that
			// database with our database.
			this.getReadableDatabase();

			try {
				copyDataBasePois();
			} catch (IOException e) {
				throw new Error("Error copying database");
			}
		}
	}

	private boolean checkDataBase() {

		SQLiteDatabase checkDB = null;

		try {
			String myPath = DATABASE_PATH + this.DATABASE_NAME;
			checkDB = SQLiteDatabase.openDatabase(myPath, null,
					SQLiteDatabase.OPEN_READONLY);
		} catch (SQLiteException e) {
			// database does't exist yet.
		}

		if (checkDB != null) {
			checkDB.close();
		}

		return (checkDB != null) ? true : false;
	}
	private boolean checkDataBasePois() {

		SQLiteDatabase checkDBPOIS = null;

		try {
			String myPath2 = DATABASE_PATH + DATABASE_NAME_POIS;
			checkDBPOIS = SQLiteDatabase.openDatabase(myPath2, null,
					SQLiteDatabase.OPEN_READONLY);
		} catch (SQLiteException e) {
			// database does't exist yet.
		}

		if (checkDBPOIS != null) {
			checkDBPOIS.close();
		}

		return (checkDBPOIS != null) ? true : false;
	}

	private void copyDataBase() throws IOException {
		// Open your local db as the input stream
		InputStream myInput = myContext.getAssets().open(this.DATABASE_NAME);

		// Path to the just created empty db
		String outFileName = DATABASE_PATH + this.DATABASE_NAME;

		// Open the empty db as the output stream
		OutputStream myOutput = new FileOutputStream(outFileName);

		// transfer bytes from the inputfile to the outputfile
		byte[] buffer = new byte[1024];
		int length;
		while ((length = myInput.read(buffer)) > 0) {
			myOutput.write(buffer, 0, length);
		}

		// Close the streams
		myOutput.flush();
		myOutput.close();
		myInput.close();
	}
	
	private void copyDataBasePois() throws IOException {
		// Open your local db as the input stream
		InputStream myInput2 = myContext.getAssets().open(DATABASE_NAME_POIS);

		// Path to the just created empty db
		String outFileName2 = DATABASE_PATH + DATABASE_NAME_POIS;

		// Open the empty db as the output stream
		OutputStream myOutput2 = new FileOutputStream(outFileName2);

		// transfer bytes from the inputfile to the outputfile
		byte[] buffer2 = new byte[1024];
		int length2;
		while ((length2 = myInput2.read(buffer2)) > 0) {
			myOutput2.write(buffer2, 0, length2);
		}

		// Close the streams
		myOutput2.flush();
		myOutput2.close();
		myInput2.close();
	}

	public void openDataBase() throws SQLException {
		// Open the database
		String myPath = DATABASE_PATH + this.DATABASE_NAME;
		database = SQLiteDatabase.openDatabase(myPath, null,
				SQLiteDatabase.OPEN_READONLY);

		String myPath2 = DATABASE_PATH + DATABASE_NAME_POIS;
		databasePois = SQLiteDatabase.openDatabase(myPath2, null,
				SQLiteDatabase.OPEN_READONLY);
	}

	@Override
	public synchronized void close() {
		if ((database != null) && (databasePois != null)) {
			database.close();
			databasePois.close();
		}
		super.close();
	}

	@Override
	public void onCreate(SQLiteDatabase db) {

	}

	@Override
	public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {

	}

	public Double[] siguientePunto(String posicion) {
		String[] ps = new String[] { posicion };

		String myPath = DATABASE_PATH + this.DATABASE_NAME;
		SQLiteDatabase database = SQLiteDatabase.openDatabase(myPath, null,
				SQLiteDatabase.OPEN_READONLY);
		// String sql =
		// "SELECT latitud, longitud FROM RutaCaminoFrances LIMIT 10";
		String sql = "SELECT latitud, longitud FROM RutaPamplona WHERE _id = ?";
		// Cursor c = database.rawQuery(sql, null);
		Cursor c = database.rawQuery(sql, ps);
		// int numrows = c.getCount();

		double latitud = 0, longitud = 0;

		c.moveToFirst();
		while (!c.isAfterLast()) {
			latitud = Double.parseDouble(c.getString(0));
			longitud = Double.parseDouble(c.getString(1));
			c.moveToNext();
		}

		c.close();
		database.close();

		Double[] pos = new Double[] { latitud, longitud };
		return pos;
	}
}